"{ Package: 'stx:goodies/petitparser/compiler' }"

"{ NameSpace: Smalltalk }"

Object subclass:#PPCMethod
	instanceVariableNames:'buffer variables indentation id profile variableForReturn'
	classVariableNames:''
	poolDictionaries:''
	category:'PetitCompiler-Core'
!


!PPCMethod class methodsFor:'as yet unclassified'!

new
    "return an initialized instance"

    ^ self basicNew initialize.
! !

!PPCMethod methodsFor:'as yet unclassified'!

add: string
	self nl.
	indentation timesRepeat: [ buffer nextPut: Character tab  ].
	self addOnLine: string.
!

addOnLine: string
	buffer nextPutAll: string.
!

addVariable: name
    <resource: #obsolete>
    self obsoleteFeatureWarning:'Use #allocateTemporaryVariableNamed: instead'.
    self error: 'Should no longer be used'

    "Modified: / 02-05-2015 / 06:49:10 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

body
	^ buffer contents
!

bridge
	^ PPCBridge on: self methodName.
!

call
	^ 'self ', self methodName, '.'.
!

code
	^ self methodName, Character cr asString,  
		self variables, Character cr asString,
		self profilingBegin, Character cr asString,
		self body, Character cr asString
"               self profilingEnd"

    "Modified: / 23-04-2015 / 19:26:39 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

dedent
	indentation := indentation - 1
!

id: value
	id := value
!

indent 
	indentation := indentation + 1
!

isInline
	^ false
!

isMethod
	^ true
!

methodName
	^ id
!

nl
	^ buffer nextPut: Character cr
!

profile
	^ profile
!

profile: aBoolean
	profile := aBoolean 
!

profilingBegin
	self profile ifTrue: [ 
 		^ '  context methodInvoked: #', id, '.'	
	].
	^ ''
!

profilingEnd
	self profile ifTrue: [ 
 		^ '  context methodFinished: #', id, '.'	
	].
	^ ''
!

returnVariable
    ^  variableForReturn

    "Created: / 23-04-2015 / 20:50:50 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

returnVariable: aString
    ^ variableForReturn := aString

    "Created: / 23-04-2015 / 18:23:47 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 23-04-2015 / 21:08:54 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

variables
	^ '  | ', (variables inject: '' into: [ :s :e | s, ' ', e]), ' |'
! !

!PPCMethod methodsFor:'code generation - variables'!

allocateReturnVariable
    
	^ variableForReturn isNil ifTrue:[ 
		variableForReturn := self allocateTemporaryVariableNamed: 'retval'  
	] ifFalse:[ 
		variableForReturn
	].

    "Created: / 23-04-2015 / 18:03:40 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

allocateTemporaryVariableNamed:preferredName 
    "Allocate a new variable with (preferably) given name.
     Returns a real variable name that should be used."
    
    (variables includes:preferredName) ifFalse:[
	variables add:preferredName.
	^ preferredName
    ] ifTrue:[
	| name |

	name := preferredName , '_' , (variables size + 1) printString.
	variables add:name.
	^ name
    ].

    "Created: / 23-04-2015 / 17:37:55 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!PPCMethod methodsFor:'initialization'!

initialize
	buffer := WriteStream on: ''.
	indentation := 1.
	variables := OrderedCollection new.
! !

!PPCMethod methodsFor:'printing & storing'!

printOn:aStream
    "append a printed representation if the receiver to the argument, aStream"

    super printOn:aStream.
    aStream nextPutAll:' id: '.
    id printOn:aStream.

    "Modified: / 23-04-2015 / 12:32:30 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!PPCMethod class methodsFor:'documentation'!

version_HG

    ^ '$Changeset: <not expanded> $'
! !

